'''A Basicaly Utility/Admin Script
    By: J3ff Hoogland'''

import es, gamethread, popuplib, keyvalues, time

#Add Info
info = es.AddonInfo()
info.name = 'J3ff\'s Admin'
info.version = '0.7'
info.url = 'http://addons.eventscripts.com/addons/view/j3ffadmin'
info.basename = 'j3ffadmin'
info.author = 'J3ff Hoogland'
es.ServerVar('ja_version',info.version,'JAdmin By: J3ff Hoogland').makepublic()

#Global Vars
Admins = {}
ServerVars = {'Advert_Timer':20}
Delay_List = ['j3ff adverts']
Commands = ['ja_makeadmin',
        'ja_var',
        'ja_rcon',
        'ja_changemap',
        'ja_setmap',
        'ja_addflags',
        'ja_removeflags',
        'ja_removeadmin',
        'ja_kick',
        'ja_ban',
        'ja_parsefiles',
        'ja_addcomment']
ChatCommands = ['timeleft',
                'nextmap']
gamedir = str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/').split('/')[~0]
AddonPath = es.getAddonPath('j3ffadmin')

#Global Methods
def load():
    for Var in ServerVars:
        es.ServerVar(Var).set(ServerVars[Var])
    for command in Commands:
        if not es.exists('command', command):
            es.regcmd(command, 'j3ffadmin/%s'%command)
        if not es.exists('clientcommand', command):
            es.regclientcmd(command, 'j3ffadmin/%s'%command)
        if not es.exists('saycommand', command):
            es.regsaycmd(command, 'j3ffadmin/%s'%command)
    for command in ChatCommands:
        if not es.exists('saycommand', command):
            es.regsaycmd(command, 'j3ffadmin/%s'%command)
    if not es.exists('clientcommand', 'admin'):
        es.regclientcmd('admin', 'j3ffadmin/admin')
    if not es.exists('saycommand', 'admin'):
        es.regsaycmd('admin', 'j3ffadmin/admin')
    if not es.exists('saycommand', '@'):
        es.regsaycmd('@', 'j3ffadmin/adminchat')
    ja_parsefiles()
    BuildMenus()

def unload():
    for delay in Delay_List:
        gamethread.cancelDelayed(delay)

def es_map_start(ev):
    global TimeStart
    TimeStart = int(es.gettime())
    Advert_Loop()

def Advert_Loop(Count=0):
    es.msg('#multi', Adverts[Count])
    Count += 1
    if Count >= len(Adverts):
        Count = 0
    gamethread.delayedname(int(es.ServerVar('Advert_Timer')), 'j3ff adverts', Advert_Loop, Count)

def __ParseFiles():
    global Adverts
    Adverts = []
    global CVars
    CVars = {'sv':[],
        'mp':[],
        'es':[],
        'other':[]}
    advert_file = open(AddonPath+'/adverts.txt')
    for line in advert_file:
        Adverts.append(line.replace('\n', ''))
    advert_file.close()
    cvar_file = open(AddonPath+'/cvarcontrol.txt')
    for line in cvar_file:
        if not line.statswith('//'):
            if 'sv_' in line:
                CVars['sv'].append(line.replace('\n', ''))
            elif 'mp_' in line:
                CVars['mp'].append(line.replace('\n', ''))
            elif 'eventscripts' in line:
                CVars['es'].append(line.replace('\n', ''))
            else:
                CVars['other'].append(line.replace('\n', ''))
    cvar_file.close()
    if es.exists('keygroup', 'jadmins'):
        es.keygroupdelete('jadmins')
    es.keygroupload('jadmins', '|j3ffadmin')
    jadmins = keyvalues.getKeyGroup('jadmins')
    for steamid in jadmins:
        if steamid not in Admins:
            Admins[steamid] = []
        for key in steamid:
            if jadmins[steamid][key] == 'flag':
                Admins[steamid].append(key)

def hasFlag(userid, flag):
    steamid = es.getplayersteamid(userid)
    if steamid in Admins:
        if flag in Admins[steamid] or 'full' in Admins[steamid]:
            return 1
        else:
            return 0
    else:
        return 0

def logAction(userid, command, comments=['n/a']):
    steamid = es.getplayersteamid(userid)
    adminfile = open(AddonPath+'/logs/%s_log.txt'%steamid.split(':')[2], 'w')
    adminfile.write('Admin - %s\n'%es.getplayername(userid))
    adminfile.write('Date - %s'%time.strftime('%x %X\n'))
    adminfile.write(' Command: %s\n'%command)
    adminfile.write(' - Comments -\n')
    for comment in comments:
        adminfile.write('  %s\n'%comment)
    adminfile.close()

#Core admin command handels
def admin(userid=""):
    if not userid:
        userid = es.getcmduserid()
    if es.getplayersteamid(userid) in Admins:
        amenu = popuplib.easymenu('easymenu', None, adminselect)
        amenu.settitle("Admin Menu")
        if hasFlag(userid, 'kick'):
            amenu.addoption('kick', 'Kick a Player')
        if hasFlag(userid, 'ban'):
            amenu.addoption('ban', 'Ban a Player')
        if hasFlag(userid, 'mapset'):
            amenu.addoption('mapset', 'Set Next Map')
        if hasFlag(userid, 'mapchange'):
            amenu.addoption('mapchange', 'Change Current Map')
        if hasFlag(userid, 'var'):
            amenu.addoption('var', 'Adjust Server Vars')
    else:
        es.tell(userid, '#multi', '#lightgreenYou are not an admin.')

def adminselect(userid, choice, popupid):
    if choice == 'var':
        varmenu.send(userid)
    elif choice == 'mapset':
        mapmenu(userid, 'set')
    elif choice == 'mapchange':
        mapmenu(userid, 'change')
    elif choice == 'kick':
        playermenu(userid, 'kick')
    elif choice == 'ban':
        playermenu(userid, 'ban')

def mapmenu(userid, kind):
    maps = open('%s/maplist.txt'%gamedir)
    mapmenu = popuplib.easymenu('map menu', None, mapselect)
    if kind == 'set':
        mapmenu.settitle('Set the next map to:')
    elif kind == 'change':
        mapmenu.settitle('Change map to:')
    counter = 0
    for map in maps:
        counter += 1
        mapmenu.addoption((kind, map), map)
        if counter == 7:
            mapmenu.addoption('back', 'Back')
    if counter < 7:
        mapmenu.addoption('back', 'Back')
    mapmenu.send(userid)

def mapselect(userid, choice, popupid):
    if choice == 'back':
        admin(userid)
    elif choice[0] == 'set':
        ja_setmap(userid, choice[1])
    elif choice[0] == 'change':
        ja_changemap(userid, choice[1])

def playermenu(userid, kind):
    players = es.getUseridList()
    playermenu = popuplib.easymenu('player menu', None, playerselect)
    if kind == 'kick':
        playermenu.settitle('Select a Player to Kick:')
    elif kind == 'ban':
        playermenu.settitle('Selecta Player to Ban:')
    counter = 0
    for player in players:
        counter += 1
        playermenu.addoption((kind, player), es.getplayername(player))
        if counter == 7:
            playermenu.addoption('back', 'Back')
    if counter < 7:
        playermenu.addoption('back', 'Back')
    playermenu.send(userid)

def playerselect(userid, choice, popupid):
    if choice == 'back':
        admin(userid)
    elif choice[0] == 'kick':
        ja_kick(choice[1])
    elif choice[0] == 'ban':
        ja_ban(choice[1])

def adminchat():
    userid = es.getcmduserid()
    if hasFlag(userid, 'chat'):
        es.msg('#multi', '#lightgreen-{ Admin %s }- #green: #lightgreen%s'%(es.getplayername(userid), es.getargs()))

#Chat Commands for players
def timeleft():
    SecondsRemaining = int(es.gettime())-TimeStart
    MinsRemaining = 0
    while SecondsRemaining >= 60:
        SecondsRemaining -= 60
        MinsRemaining += 1
    es.tell(es.getcmduserid(), '#multi', '#defaultThe time remaining is #lightgreen%s minets #defaultand #lightgreen%s seconds#default.'%(MinsRemaining, SecondsRemaining))

def nextmap():
    es.tell(es.getcmduserid(), '#multi', '#defaultThe next map is #green%s'%(es.ServerVar('eventscripts_nextmapoverride')))

#Commands
def ja_parsefiles():
    userid = es.getcmduserid()
    if userid:
        if not hasFlag(userid, 'full'):
            return
    global Admins
    Admins = {}
    es.server.queuecmd('exec j3ffconfig.cfg')
    gamethread.delayed(.1, __ParseFiles)
    if userid:
        logAction(userid, 'ja_parsefiles')

def ja_kick(target=""):
    userid = es.getcmduserid()
    if userid:
        if not hasFlag(userid, 'kick'):
            return
    if not target:
        target = es.getuserid(es.getargv(1))
    if userid:
        logAction(userid, 'ja_kick', ['Player Kicked - %s (Steamid - %s)'%(es.getplayername(target), es.getplayersteamid(target))])
    es.server.queuecmd('kickid %s'%target)

def ja_ban(target="",duration=0):
    userid = es.getcmduserid()
    if userid:
        if not hasFlag(userid, 'ban'):
            return
    if not target:
        target = es.getuserid(es.getargv(1))
        duration = int(es.getargv(2))
    if userid:
        logAction(userid, 'ja_ban', ['Player Banned - %s (Steamid - %s)'%(es.getplayername(target), es.getplayersteamid(target)), 'Duration - %s (0 = Forever)'%duration])
    es.server.queuecmd('banid %s %s kick'%(duration, target))

def ja_rcon():
    userid = es.getcmduserid()
    if userid:
        if not hasFlag(userid, 'full'):
            return
        logAction(userid, 'ja_rcon', ['Command and Args Fired : %s'%es.getargs()])
    es.server.queuecmd(es.getargs())

def ja_makeadmin(steamid="",flags=[],comments=[]):
    userid = es.getcmduserid()
    if userid:
        if not hasFlag(userid, 'full'):
            return
    if not steamid:
        if 'STEAM' not in str(es.getargv(1)):
            steamid = es.getplayersteamid(es.getuserid(str(es.getargv(1))))
        else:
            steamid = str(es.getargv(1))
    if not flags:
        flags = str(es.getargv(2)).split(',')
    if not comments:
        comments = str(es.getargv(3)).split(',')
    if not flags:
        flags = ['full']
    if es.exists('key', 'jadmins', steamid):
        es.keydelete('jadmins', steamid)
    es.keycreate('jadmins', steamid)
    Admins[steamid] = []
    for flag in flags:
        es.keysetvalue('jadmins', steamid, flag, 'flag')
        Admins[steamid].append(flag)
    for comment in comments:
        es.keysetvalue('jadmins', steamid, comment, 'comment')
    if userid:
        logAction(userid, 'ja_makeadmin', ['Steamid Made Admin: %s'%steamid, 'Flags Given: %s'%flags, 'Comments Made: %s'%comments])

def ja_removeadmin():
    userid = es.getcmduserid()
    if userid:
        if not hasFlag(userid, 'full'):
            return
    if 'STEAM' not in str(es.getargv(1)):
        steamid = es.getplayersteamid(es.getuserid(str(es.getargv(1))))
    else:
        steamid = str(es.getargv(1))
    if steamid in Admins:
        if 'full' not in Admins[steamid]:
            del Admins[steamid]
            es.keydelete('jadmins', steamid)
            if userid:
                logAction(userid, 'ja_removeadmin', ['Steamid Removed: %s'%steamid])

def ja_addflags():
    userid = es.getcmduserid()
    if userid:
        if not hasFlag(userid, 'full'):
            return
    if 'STEAM' not in str(es.getargv(1)):
        steamid = es.getplayersteamid(es.getuserid(str(es.getargv(1))))
    else:
        steamid = str(es.getargv(1))
    flags = str(es.getargv(2)).split(',')
    if steamid in Admins:
        for flag in flags:
            Admins[steamid].append(flag)
            es.keysetvalue('jadmins', steamid, flag, 'flag')
    else:
        ja_makeadmin(steamid, flags)
    if userid:
        logAction(userid, 'ja_addflags', ['Steamid Edited: %s'%steamid, 'Flags Added: %s'%es.getargv(2)])

def ja_removeflags():
    userid = es.getcmduserid()
    if userid:
        if not hasFlag(userid, 'full'):
            return
    if 'STEAM' not in str(es.getargv(1)):
        steamid = es.getplayersteamid(es.getuserid(str(es.getargv(1))))
    else:
        steamid = str(es.getargv(1))
    flags = str(es.getargv(2)).split(',')
    if steamid in Admins:
        for flag in flags:
            if hasFlag(steamid, flag) and 'full' not in Admins[steamid]:
                es.keysetvalue('jadmins', steamid, flag, 'removed')
                Admins[steamid].remove(flag)
    if userid and 'full' not in Admins[steamid]:
        logAction(userid, 'ja_addflags', ['Steamid Edited: %s'%steamid, 'Flags Added: %s'%flags])

def ja_addcomment():
    userid = es.getcmduserid()
    if userid:
        if not hasFlag(userid, 'full'):
            return
    if 'STEAM' not in str(es.getargv(1)):
        steamid = es.getplayersteamid(es.getuserid(str(es.getargv(1))))
    else:
        steamid = str(es.getargv(1))
    comments = str(es.getargv(2)).split(',')
    if steamid in Admins:
        for comment in comments:
            es.keysetvalue('jadmins', steamid, comment, 'comment')
        if userid:
            logAction(userid, 'ja_addcomment', ['Steamid Edited: %s'%steamid, 'Comments Added: %s'%es.getargv(2)])

def ja_var():
    userid = es.getcmduserid()
    if userid:
        if not hasFlag(userid, 'var'):
            return
        logAction(userid, 'ja_var', ['Var Changed - %s'%es.getargv(1), 'New Value - %s'%es.getargv(2)])
    es.ServerVar(es.getargv(1)).set(es.getargv(2))

def ja_changemap(userid="",map=""):
    if not userid:
        userid = es.getcmduserid()
    if userid:
        if not hasFlag(userid, 'mapchange'):
            return
        es.msg('#multi', '#lightgreen-{ Admin %s }- #defaulthas is changing the map to: #green%s'%(es.getplayername(userid), map))
        logAction(userid, 'ja_changemap', ['Map Changed To - %s'%map])
    else:
        es.msg('#multi', '#lightgreenThe is changing the map to: #green%s'%(map))
    if not map:
        map = str(es.getargv(1))
    gamethread.delayed(2, es.server.queuecmd, ('changelevel %s'%map))

def ja_setmap(userid="",map=""):
    if not userid:
        userid = es.getcmduserid()
    if userid:
        if not hasFlag(userid, 'mapset'):
            return
        es.msg('#multi', '#lightgreen-{ Admin %s }- #defaulthas set the next map to: #green%s'%(es.getplayername(userid), map))
        logAction(userid, 'ja_changemap', ['Next Map Set To - %s'%map])
    else:
        es.msg('#multi', '#lightgreenThe next map has been set to: #green%s'%(map))
    if not map:
        map = str(es.getargv(1))
    es.ServerVar('eventscripts_nextmapoverride').set(map)

#Builds all static menus for the mod
def BuildMenus():
    global varmenu
    varmenu = popuplib.create('varmenu')
    varmenu.addline("What Type of Server_Var would you like to Change:")
    varmenu.addline("-> 1. sv_ CVars")
    varmenu.addline("-> 2. mp_ CVars")
    varmenu.addline("-> 3. Event Scripts CVars")
    varmenu.addline("-> 4. Misc. Server Vars")
    varmenu.addline("-> 9. Back")
    varmenu.addline("0. Exit")
    varmenu.menuselect = VarMenuSelect

#Our Menu Select Handels
def VarMenuSelect(userid, choice, popupid):
    mymenu = popuplib.easymenu('x menu', None, VarSelected)
    mymenu.settitle('Select a var to edit the value of:')
    counter = 0
    if choice == 1:
        for Var in CVars['sv']:
            counter += 1
            mymenu.addoption(Var, '%s (%s)'%(Var, es.ServerVar(Var)))
            if counter == 7:
                mymenu.addoption('back', 'Back')
    elif choice == 2:
        for Var in CVars['mp']:
            counter += 1
            mymenu.addoption(Var, '%s (%s)'%(Var, es.ServerVar(Var)))
            if counter == 7:
                mymenu.addoption('back', 'Back')
    elif choice == 3:
        for Var in CVars['es']:
            counter += 1
            mymenu.addoption(Var, '%s (%s)'%(Var, es.ServerVar(Var)))
            if counter == 7:
                mymenu.addoption('back', 'Back')
    elif choice == 4:
        for Var in CVars['other']:
            counter += 1
            mymenu.addoption(Var, '%s (%s)'%(Var, es.ServerVar(Var)))
            if counter == 7:
                mymenu.addoption('back', 'Back')
    elif choice >= 5 and choice <= 8:
        varmenu.send(userid)
    elif choice == 9:
        admin(userid)
    if choice <= 4:
        if counter < 7:
            mymenu.addoption('back', 'Back')
        mymenu.send(userid)

def VarSelected(userid, Var, popupid):
    if Var == 'back':
        varmenu.send(userid)
    else:
        es.escinputbox(10, userid, 'J3ff Admin - Change Variable', 'Set the value of %s to'%Var, 'ja_var %s'%Var)
    
